<?php

// получение данных из бд
function db_out($db){
	$sql = $db->query("SELECT id, alt_name, xfields FROM ". PREFIX ."_post");
	$out = array();

	while ( $row = $db->get_row( $sql ) ) {
		$out['id'][]       = $row['id'];
		$out['alt_name'][] = $row['alt_name'];
		$out['xfields'][]  = xfieldsdataload($row['xfields']);
	}
	$db->free( $sql );
	return $out;
}

// проверка GET параметров
function getValue ($val, $two = false){
	if(!empty($_GET[$val])) $val = $_GET[$val];
	else $val = $two;
	return $val;
}

// тип видео для url
function typeMovies ($category){
    $movies_array = array('movies', 'camrip', 'russian', 'anime');
    if (in_array($category, $movies_array)) $type = 'movies';
    else $type = 'serials';
	return $type;
}


// хвост для url api
function plusUrl ($category){
    if ($category == 'movies')        $plus_url = '';       
    if ($category == 'camrip')        $plus_url = '&category=CamRip';      
    if ($category == 'russian')       $plus_url = '&category=Russian';     
    if ($category == 'anime')         $plus_url = '&category=Anime';
    if ($category == 'serials')       $plus_url = '';
    if ($category == 'anime_serials') $plus_url = '&category=Anime';
	if ($category == 'ukraine')       $plus_url = '';
	if ($category == 'block')         $plus_url = '';
	return $plus_url;
}


/**
*
*	Подсчет строк для вывода постанично, возвращает массив: start - finish
*	Параметры: 1 - текущий номер страницы, 2 - кол-во строк в массиве, 3 - сколько строк выводить на странице
*
*/
function rowsCulc ($page, $n_array, $rows = 50) {

	$result = array();
	if ($page < 2 || $page == false)
	{
		$start = 0;
		$finish = $start + $rows;
		$finish = ($n_array < $finish) ? $n_array : $rows;
	}
	else 
	{			
		$start = ($page - 1) * $rows;
		$finish = $start + $rows;
		$finish = ($n_array < $finish) ? $n_array : $finish ;
	}
	$result['start']  = $start;
	$result['finish'] = $finish;
	return $result;
}

// данные по блокировкам
function block_cauntry ($block_obj) {

	if ($block_obj->block_ru) $result = 'RU';
	if ($block_obj->block_ua) $result = 'UA';
	if ($block_obj->block_ru && $block_obj->block_ua) $result = 'RU, UA';
	if ($result) $result = '<span class="status-info tip" data-original-title="' . $block_obj->blocked_at . '"><span class="label label-danger">'. $result .'</span></span>';
	return $result;
}


// URL-ы для получения данных по API 
function urlAPI ($arr){
	$url = '';

	if ($arr['category'] == 'ukraine') 
		$url = 'http://moonwalk.cc/api/serials_foreign.json?api_token='.$arr['api_token'].$arr['plus_url'];
	elseif ($arr['category'] == 'block' &&  $arr['catblock'] == 'films') 
		$url = '';
	elseif ($arr['category'] == 'block' &&  $arr['catblock'] == 'films_ru') 
		$url = 'http://moonwalk.cc/api/movies_russian.json?api_token='.$arr['api_token'];	
	elseif ($arr['category'] == 'block' &&  $arr['catblock'] == 'films_en') 
		$url = 'http://moonwalk.cc/api/movies_foreign.json?api_token='.$arr['api_token'];			
	elseif ($arr['category'] == 'block' &&  $arr['catblock'] == 'serials') 
		$url = 'http://moonwalk.cc/api/serials_foreign.json?api_token='.$arr['api_token'];
	elseif ($arr['category'] == 'block' &&  $arr['catblock'] == 'serials_ru') 
		$url = 'http://moonwalk.cc/api/serials_russian.json?api_token='.$arr['api_token'];	
    else 
    	$url = 'http://moonwalk.cc/api/'.$arr['type'].'_updates.json?api_token='.$arr['api_token'].$arr['plus_url'].'&page='.$arr['page'];	

    return $url;
}


// проверка существования актуального кэша
function contentCache ($url,$settings){
	
	// если данные таба кэшируются
	if ( in_array($settings['category'], $settings['cat_cache']) ) {
		
		// получаю последние значение из get-строки (кроме page), чтобы использовать для имении файла кэша
		$query = parse_url($_SERVER['REQUEST_URI']);
		parse_str($query['query'], $arr_url);		
		unset($arr_url['page']); 
		if (count($arr_url) < 3 ) $cache_name = end($arr_url);
		else $cache_name = end($arr_url) . '_' . $settings['category'];

		// единый файл, т.к. данные из api одинаковые
		if ($cache_name == 'serials_block') $cache_name = 'serials_en';
		if ($cache_name == 'ukraine')       $cache_name = 'serials_en';

		// если есть актуальный файл в кэше, то считываю
		if ( issetCacheFile($cache_name) ) {
			$content_obj = fileExObj (ENGINE_DIR . '/inc/moonbase/cache/'.$cache_name.'.txt');
			return $content_obj;			
		} 
		// иначе парсинг напрямую и запись в файл
		else {
			$content_obj = parsURL ($url);
			$content_str = serialize($content_obj);
			file_put_contents(ENGINE_DIR.'/inc/moonbase/cache/'.$cache_name.'.txt',  $content_str);
			return $content_obj;			
		}
	} 
	// иначе парсинг напрямую
	else 
		$content_obj = parsURL ($url);

	return $content_obj;
}



// парсинг контента
function parsURL ($url){
    if ( $curl = curl_init() ) {
       curl_setopt($curl, CURLOPT_URL, $url);
       curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
       curl_setopt($curl, CURLOPT_FOLLOWLOCATION, 1);
       curl_setopt($curl, CURLOPT_ENCODING, "");
       curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, 6);
       curl_setopt($curl, CURLOPT_TIMEOUT, 9);
       curl_setopt($curl, CURLOPT_MAXREDIRS, 10);
       curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
       curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
       $output = curl_exec($curl);
       $content  = json_decode($output);
       curl_close($curl);
    } else $content = json_decode(file_get_contents($url));	
    return $content;
}

function myPrint ($mass){
	echo '<pre>';
	print_r($mass);
	echo '</pre>';
}

// Проверка на существование файла и проверка его на возраст
function issetCacheFile ($file_name) {
	$res = false;
	$chekfile = ENGINE_DIR . '/inc/moonbase/cache/'.$file_name.'.txt';
	// если файл существует и больше 20 байт
	if( file_exists ($chekfile) AND filesize($chekfile) > 20) {
		// чекаю на возраст на актуальность
		$age = fileAge ($chekfile);
		if ($age) $res = true;	
	}
	return $res;
}

// актуальный возраст файла, если старше - не актуальный
function fileAge ($chekfile, $interval = 12) {
	$timeout = $interval * 60 * 60; // 12 часов
	$file_date = @filemtime($chekfile);
	$file_date = time()-$file_date;	
	$buffer = ( $file_date >  $timeout ) ? false : true;
	return $buffer;
}

// Если файл есть, то читает и возвращает массив, иначе возвращает пустой массив
function fileExObj ($path_file){
	$mass = array();    
	if( file_exists ($path_file) ){
	  $id_str = file_get_contents($path_file);
	  $mass = unserialize($id_str);
	}
	return $mass;   
}

// смена кодировки, если не utf-8
function myIconv ($val,$config){
	$charset = ( strtolower($config['charset']) != 'utf-8' ) ? true : false;
	if ($charset) $val = iconv('utf-8', 'windows-1251', $val);
	return $val;
}


//===============================================================================
//=====                                        ==================================
//=====       Для вывода данных в таблицы      ==================================												
//=====                                        ==================================
//===============================================================================

// вывод данных в таблицу для вкладки UA
function showTableUA ($content, $settings){
	
	$content  = $content->{'report'}->serials;
	$nSerials = count ($content); // количество сериалов в api json	
	$nFilmBD  = $settings['n_film_bd'];                // количество новостей в базе сайта
	$serials  = array();
	
	// Отбираю в массив сериалы с украинским переводом (имеет id 103)
    for ( $m=0; $m < $nSerials; $m++ ){
		if ( $content[$m]->{'translator_id'} == 103 ) {
			$serials['title_ru'][]       = myIconv ($content[$m]->title_ru, $settings['config']); // автосмена кодировки, если не utf-8
			$serials['title_en'][]       = $content[$m]->title_en;
			$serials['idkp'][]           = $content[$m]->kinopoisk_id;
			$serials['seasons_count'][]  = $content[$m]->seasons_count;
			$serials['episodes_count'][] = $content[$m]->episodes_count;
			$serials['iframe_url'][]     = iconIframe ($content[$m]->iframe_url);
			$serials['block'][]          = block_cauntry($content[$m]->block);
			$serials['blocked_at'][]     = $content[$m]->block->blocked_at;
		}
    }
   
	$n_serials = count ($serials['idkp']);		
	$serials_have = array();
	 
	// Получаю сериалы, которые есть в базе
    for ( $m=0; $m < $n_serials; $m++ ){
      for ( $i=0; $i < $nFilmBD; $i++ ){
		  
         $kp_id_moon_s = $serials['idkp'][$m];
		 $serials['edit'][$m] = '';
		 $serials['have'][$m] = iconCheck ('no');
		 
         // если kinopoisk_id совпадает, то забираю данные и останавливаю цикл
         if ( $settings['out']['xfields'][$i][$settings['kpid_name']] == $kp_id_moon_s AND $kp_id_moon_s !== NULL ) {
			
			$serials['title_ru'][$m] = iconLink  ($i,$serials['title_ru'][$m],$settings,'R');
			$serials['title_en'][$m] = iconLink  ($i,$serials['title_en'][$m],$settings,'E');
			$serials['edit'][$m]     = iconEdit  ($settings['out']['id'][$i],$settings);
			$serials['have'][$m]     = iconCheck ('yes');
			
			break;
         }
      }
    }
	
	return $serials;
}


// данные для вкладки Блокировки Сериалы
function showTableBlockS ($content, $settings){
	
	$content = $content->{'report'}->serials;
	$nSerials = count ($content);        // количество сериалов в api json
	$nFilmBD  = $settings['n_film_bd'];   // количество новостей в базе сайта
	$kinopoisk_id_m = '';
	$ArrBlockS = array();
	$i = 0;
	// Отбираю в массив заблокированные сериалы
	for ( $m=0; $m < $nSerials; $m++ ){

		$block_obj = $content[$m]->block;
		$block = block_cauntry ($block_obj);
		
		if ($block) {
			if ($kinopoisk_id_m != $content[$m]->kinopoisk_id ) {
				$ArrBlockS[$i]['title_ru']       = myIconv ( $content[$m]->title_ru, $settings['config'] );
				$ArrBlockS[$i]['title_clear']    = $ArrBlockS['title_ru'][$i];   
				$ArrBlockS[$i]['title_en']       = $content[$m]->title_en;
				$ArrBlockS[$i]['idkp']           = $content[$m]->kinopoisk_id;
				$ArrBlockS[$i]['seasons_count']  = $content[$m]->seasons_count;
				$ArrBlockS[$i]['episodes_count'] = $content[$m]->episodes_count;
				$ArrBlockS[$i]['iframe_url']     = iconIframe ( $content[$m]->iframe_url );
				$ArrBlockS[$i]['block']          = $block;
				$ArrBlockS[$i]['blocked_at']     = $content[$m]->block->blocked_at;
				$ArrBlockS[$i]['have']           = iconCheck ('no');
				$i++;
			}
		}
		
		// для отбора в массив только уникальных сериалов (без повторений с разными переводами)
		$kinopoisk_id_m = $content[$m]->{'kinopoisk_id'};
	}
	
    $nBlock  = count ($ArrBlockS);
    $nFilmBD = count ($settings['out']['id']);   // количество фильмов в базе сайта

    for ( $m=0; $m < $nBlock; $m++ ){
      for ( $i=0; $i < $nFilmBD; $i++ ){
         $kp_id_moon = $ArrBlockS[$m]['idkp'];			 		 
         // если kinopoisk_id совпадает, то забираю данные и останавливаю цикл
         if ( $settings['out']['xfields'][$i][$settings['kpid_name']] == $kp_id_moon AND $kp_id_moon !== NULL ) {

			$ArrBlockS[$m]['title_ru'] = iconLink  ($i,$ArrBlockS[$m]['title_ru'],$settings,'R');
			$ArrBlockS[$m]['title_en'] = iconLink  ($i,$ArrBlockS[$m]['title_en'],$settings,'E');		
            $ArrBlockS[$m]['edit']     = iconEdit  ($settings['out']['id'][$i],$settings);
			$ArrBlockS[$m]['have']     = iconCheck ('yes');

             break;
         }
      }
    }
	
	// сортировка массива по убыванию даты в blocked_at
	usort($ArrBlockS, 'mysort' );

	return $ArrBlockS;
}

// сортировка массива по значению blocked_at
function mysort($a,$b) { return $a['blocked_at'] < $b['blocked_at'];}

// данные для вкладки Блокировки Фильмы
function showTableBlockF ($content, $settings){
	
	$content        = $content->{'report'}->{'movies'};
	$nFilmsApi      = count ($content);         // количество фильмов в api json
	$nFilmBD        = $settings['n_film_bd'];   // количество новостей в базе сайта
	$kinopoisk_id_m = '';
	$ArrBlockF      = array();

	// Отбираю в массив заблокированные фильмы
	$i = 0;
	for ( $m=0; $m < $nFilmsApi; $m++ ){
		
		$block_obj = $content[$m]->block;
		$block = block_cauntry ($block_obj);

		if ($block) {
			$ArrBlockF[$i]['title_ru']       = myIconv ($content[$m]->title_ru, $settings['config']);
			$ArrBlockF[$i]['title_clear']	 = $ArrBlockF[$i]['title_ru'];
			$ArrBlockF[$i]['title_en']       = $content[$m]->title_en;
			$ArrBlockF[$i]['idkp']           = $content[$m]->kinopoisk_id;
			$ArrBlockF[$i]['year']           = $content[$m]->year;
			$ArrBlockF[$i]['source_type']    = ($content[$m]->source_type) ? $content[$m]->source_type : 'HDRip';
			$ArrBlockF[$i]['iframe_url']     = iconIframe ( $content[$m]->iframe_url );
			$ArrBlockF[$i]['block']          = $block;
			$ArrBlockF[$i]['blocked_at']     = $content[$m]->block->blocked_at;
			$ArrBlockF[$i]['have']           = iconCheck ('no');
			$i++;
		}
		
	}

    $nBlock  = count ($ArrBlockF);
    $nFilmBD = count ($settings['out']['id']);   // количество фильмов в базе сайта

    for ( $m=0; $m < $nBlock; $m++ ){
      for ( $i=0; $i < $nFilmBD; $i++ ){
         $kp_id_moon = $ArrBlockF[$m]['idkp'];			 		 
         // если kinopoisk_id совпадает, то забираю данные и останавливаю цикл
         if ( $settings['out']['xfields'][$i][$settings['kpid_name']] == $kp_id_moon AND $kp_id_moon !== NULL ) {

			$ArrBlockF[$m]['title_ru'] = iconLink  ($i,$ArrBlockF[$m]['title_ru'],$settings,'R');
			$ArrBlockF[$m]['title_en'] = iconLink  ($i,$ArrBlockF[$m]['title_en'],$settings,'E');		
            $ArrBlockF[$m]['edit']     = iconEdit  ($settings['out']['id'][$i],$settings);
			$ArrBlockF[$m]['have']     = iconCheck ('yes');

             break;
         }
      }
    }
	
	// сортировка массива по убыванию даты в blocked_at
	usort($ArrBlockF, 'mysort' );
	
	return $ArrBlockF;

}

// вывод данных в таблицу (для остальных вкладок)
function showTableDefault ($content, $settings){
		
    $nFilmApi = count ($content->{'updates'}); // количество фильмов с page api

	// получаю фильмы, которые есть в базе
    $films_mass_have = massHave ($content, $settings);
	
	$mass_pack = array();
	
	for ( $i=0; $i < $nFilmApi; $i++ ){
		// данные из api		
        $mass_pack['date'][$i]          = $content->{'updates'}[$i]->{'added_at'};
        $mass_pack['iframe_link'][$i]   = $content->{'updates'}[$i]->{'iframe_url'};
        $mass_pack['idkp'][$i]          = $content->{'updates'}[$i]->{'kinopoisk_id'};
        $mass_pack['title_ru'][$i]      = $content->{'updates'}[$i]->{'title_ru'};
        $mass_pack['title_en'][$i]      = $content->{'updates'}[$i]->{'title_en'};
		$mass_pack['year'][$i]          = $content->{'updates'}[$i]->{'year'};
		$mass_pack['source_type'][$i]   = $content->{'updates'}[$i]->{'source_type'};				
        $mass_pack['translator'][$i]    = $content->{'updates'}[$i]->{'translator'};
        $mass_pack['block'][$i]         = $content->{'updates'}[$i]->{'block'};
		
		// для сериалов
        if ($settings['type'] == 'serials') {
            $mass_pack['idkp'][$i]          = $content->{'updates'}[$i]->{'serial'}->{'kinopoisk_id'};
            $mass_pack['title_ru'][$i]      = $content->{'updates'}[$i]->{'serial'}->{'title_ru'};
            $mass_pack['title_en'][$i]      = $content->{'updates'}[$i]->{'serial'}->{'title_en'};
            $mass_pack['iframe_link'][$i]   = $content->{'updates'}[$i]->{'serial'}->{'iframe_url'};
            $mass_pack['translator'][$i]    = $content->{'updates'}[$i]->{'serial'}->{'translator'};
			$mass_pack['block'][$i]         = $content->{'updates'}[$i]->{'serial'}->{'block'};
        }

		// смена кодировки, если требуется
		$mass_pack['title_ru'][$i]      = myIconv ($mass_pack['title_ru'][$i], $settings['config']);
		$mass_pack['translator'][$i]    = myIconv ($mass_pack['translator'][$i], $settings['config']);	
		
		// чистое название для всех фильмов, независимо от наличия в бд
		$mass_pack['title_clear'][$i]   = $mass_pack['title_ru'][$i];		
		
		// Значения качества по-умолчанию для категорий с камрипами и hd
		if ($settings['category'] == 'camrip' && !$mass_pack['source_type'][$i]) 
			$mass_pack['source_type'][$i] = 'CAMRip';
		if ($settings['category'] == 'movies' || $settings['category'] == 'russian' AND !$mass_pack['source_type'][$i]) 
			$mass_pack['source_type'][$i] = 'HDRip';		
		
	
		
		// доп данные
		$mass_pack['info_true'][$i]     = $settings['info_true'];
		$mass_pack['type'][$i]          = $settings['type'];
		$mass_pack['category'][$i]      = $settings['category'];						
		
		$mass_pack['edit'][$i]          = '';
		$mass_pack['idbd'][$i]          = '';
		$mass_pack['link'][$i]          = '';
		
		// данные для фильмов, которые есть в базе
		if ($films_mass_have['have'][$i] == '1') { 
			$mass_pack['have'][$i]     = iconCheck ('yes');
			$mass_pack['title_ru'][$i] = '<a href="'.$films_mass_have['link'][$i].'" target="_blank" data-original-title="Перейти на страницу с материалом" class="status-info tip">'.$mass_pack['title_ru'][$i].'</a>';
			$mass_pack['title_en'][$i] = '<a href="'.$films_mass_have['link'][$i].'" target="_blank" class="status-info tip">'.$mass_pack['title_en'][$i].'</a>';
			$mass_pack['edit'][$i]     = iconEdit ($films_mass_have['idbd'][$i],$settings);
		}
		else {
			$mass_pack['have'][$i] = iconCheck ('no');
		}				
						
		// данные о блокировке по гео
		$mass_pack['block'][$i]   = block_cauntry($mass_pack['block'][$i]);		
		
        $mass_pack['iframe_link'][$i] = iconIframe ($mass_pack['iframe_link'][$i]);	
    }
	
	return $mass_pack;	
}


// отбираются в отдельной массив фильмы, которые есть в базе
function massHaveSerialsBlock ($content, $settings){
	
    $nFilmKP = count ($content);    // количество фильмов с page api
    $nFilmBD = count ($settings['out']['id']);   // количество фильмов в базе сайта

    $films_mass_have = array();
	
    for ( $m=0; $m < $nFilmKP; $m++ ){
      for ( $i=0; $i < $nFilmBD; $i++ ){
         $kp_id_moon = $content->{'updates'}[$m]->{'kinopoisk_id'};
         if ($settings['category'] == 'serials') $kp_id_moon = $content->{'updates'}[$m]->{'serial'}->{'kinopoisk_id'};
         // если kinopoisk_id совпадает, то забираю данные и останавливаю цикл
         if ( $settings['out']['xfields'][$i][$settings['kpid_name']] == $kp_id_moon AND $kp_id_moon !== NULL ) {
            $films_mass_have['have'][$m] = '1';
            $films_mass_have['link'][$m] = '/'.$settings['out']['id'][$i].'-'.$settings['out']['alt_name'][$i].'.html';
            $films_mass_have['idbd'][$m] = $settings['out']['id'][$i];
             break;
         }
      }
    }
	return $films_mass_have;
}


// отбираются в отдельной массив фильмы, которые есть в базе
function massHave ($content, $settings){
	
    $nFilmKP = count ($content->{'updates'});    // количество фильмов с page api
    $nFilmBD = count ($settings['out']['id']);   // количество фильмов в базе сайта

    $films_mass_have = array();
	
    for ( $m=0; $m < $nFilmKP; $m++ ){
      for ( $i=0; $i < $nFilmBD; $i++ ){
         $kp_id_moon = $content->{'updates'}[$m]->{'kinopoisk_id'};
         if ($settings['category'] == 'serials') $kp_id_moon = $content->{'updates'}[$m]->{'serial'}->{'kinopoisk_id'};
         // если kinopoisk_id совпадает, то забираю данные и останавливаю цикл
         if ( $settings['out']['xfields'][$i][$settings['kpid_name']] == $kp_id_moon AND $kp_id_moon !== NULL ) {
            $films_mass_have['have'][$m] = '1';
            $films_mass_have['link'][$m] = '/'.$settings['out']['id'][$i].'-'.$settings['out']['alt_name'][$i].'.html';
            $films_mass_have['idbd'][$m] = $settings['out']['id'][$i];
             break;
         }
      }
    }
	return $films_mass_have;
}


function iconCheck ($val = 'no'){
	if($val == 'no')  $icon = '<span class="status-error"><i class="icon-exclamation-sign" style="font-size: 16px;"></i></span>'; 
	if($val == 'yes') $icon = '<span class="status-success"><i class="icon-ok-sign" style="font-size: 16px;"></i></span>';
	return $icon;
}

function iconEdit ($val,$settings){
	return '<a href="'.$settings['config']['admin_path'].'?mod=editnews&action=editnews&id='.$val.'" target="_blank" data-original-title="Перейти к редактированию" class="status-info tip" ><i class="icon-edit" style="font-size:14px;"></a>';
}

function iconIframe ($val){
	return '<a href="'.$val.'" target="_blank" data-original-title="Перейти" class="status-info tip" >ссылка</a>';
}

function iconLink ($i,$title,$settings,$k){
	$link = '/'.$settings['out']['id'][$i].'-'.$settings['out']['alt_name'][$i].'.html';
	if ($k == 'E') $res = '<a href="'.$link.'" target="_blank" class="status-info tip">'.$title.'</a>';
	if ($k == 'R') $res = '<a href="'.$link.'" target="_blank" data-original-title="Перейти на страницу с фильмом" class="status-info tip">'.$title.'</a>';
	return $res;
}

?>

